## mono 6.8.0.105+dfsg

=== external/binary-reference-assemblies/Makefile ===
all:
	$(MAKE) -C v2.0
	$(MAKE) -C v3.5
	$(MAKE) -C v4.0
	$(MAKE) -C v4.5
	$(MAKE) -C v4.5.1
	$(MAKE) -C v4.5.2
	$(MAKE) -C v4.6
	$(MAKE) -C v4.6.1
	$(MAKE) -C v4.6.2
	$(MAKE) -C v4.7
	$(MAKE) -C v4.7.1
	$(MAKE) -C v4.7.2
	$(MAKE) -C v4.8
	$(MAKE) -C mono
	$(MAKE) -C build/monotouch
	$(MAKE) -C build/monodroid

clean:
	$(MAKE) -C v2.0 clean
	$(MAKE) -C v3.5 clean
	$(MAKE) -C v4.0 clean
	$(MAKE) -C v4.5 clean
	$(MAKE) -C v4.5.1 clean
	$(MAKE) -C v4.5.2 clean
	$(MAKE) -C v4.6 clean
	$(MAKE) -C v4.6.1 clean
	$(MAKE) -C v4.6.2 clean
	$(MAKE) -C v4.7 clean
	$(MAKE) -C v4.7.1 clean
	$(MAKE) -C v4.7.2 clean
	$(MAKE) -C v4.8 clean
	$(MAKE) -C mono clean
	$(MAKE) -C build/monotouch clean
	$(MAKE) -C build/monodroid clean

.PHONY: all clean

=== external/boringssl/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10)

# Defer enabling C and CXX languages.
project (BoringSSL NONE)

if(WIN32)
  # On Windows, prefer cl over gcc if both are available. By default most of
  # the CMake generators prefer gcc, even on Windows.
  set(CMAKE_GENERATOR_CC cl)
endif()

enable_language(C)
enable_language(CXX)

if(ANDROID)
  # Android-NDK CMake files reconfigure the path and so Go and Perl won't be
  # found. However, ninja will still find them in $PATH if we just name them.
  if(NOT OPENSSL_NO_ASM)
    set(PERL_EXECUTABLE "perl")
  endif()
  # set(GO_EXECUTABLE "go")
else()
  if(NOT OPENSSL_NO_ASM)
    find_package(Perl REQUIRED)
  endif()
  # find_program(GO_EXECUTABLE go)
endif()

#if (NOT GO_EXECUTABLE)
#  message(FATAL_ERROR "Could not find Go")
#endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(${CMAKE_SYSTEM_NAME} MATCHES "AIX" OR ${CMAKE_SYSTEM_NAME} MATCHES "OS400")
    # XCOFF doesn't support -fvisibility=hidden, and we would prefer XCOFF debugging info.
    set(C_CXX_FLAGS "-Wall -Wformat=2 -Wsign-compare -Wmissing-field-initializers -gxcoff")
  else()
    set(C_CXX_FLAGS "-Wall -Wformat=2 -Wsign-compare -Wmissing-field-initializers -ggdb -fvisibility=hidden")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_CXX_FLAGS}")
  if(ANDROID)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x ${C_CXX_FLAGS}")
  elseif(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ${C_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -stdlib=libc++ ${C_CXX_FLAGS}")
  endif()
elseif(MSVC)
  set(MSVC_DISABLED_WARNINGS_LIST
      "C4100" # 'exarg' : unreferenced formal parameter
      "C4127" # conditional expression is constant
      "C4200" # nonstandard extension used : zero-sized array in
              # struct/union.
      "C4242" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4244" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4245" # 'initializing' : conversion from 'long' to
              # 'unsigned long', signed/unsigned mismatch
      "C4267" # conversion from 'size_t' to 'int', possible loss of data
      "C4371" # layout of class may have changed from a previous version of the
              # compiler due to better packing of member '...'
      "C4388" # signed/unsigned mismatch
      "C4296" # '>=' : expression is always true
      "C4350" # behavior change: 'std::_Wrap_alloc...'
      "C4365" # '=' : conversion from 'size_t' to 'int',
              # signed/unsigned mismatch
      "C4389" # '!=' : signed/unsigned mismatch
      "C4464" # relative include path contains '..'
      "C4510" # 'argument' : default constructor could not be generated
      "C4512" # 'argument' : assignment operator could not be generated
      "C4514" # 'function': unreferenced inline function has been removed
      "C4548" # expression before comma has no effect; expected expression with
              # side-effect" caused by FD_* macros.
      "C4610" # struct 'argument' can never be instantiated - user defined
              # constructor required.
      "C4623" # default constructor was implicitly defined as deleted
      "C4625" # copy constructor could not be generated because a base class
              # copy constructor is inaccessible or deleted
      "C4626" # assignment operator could not be generated because a base class
              # assignment operator is inaccessible or deleted
      "C4706" # assignment within conditional expression
      "C4710" # 'function': function not inlined
      "C4711" # function 'function' selected for inline expansion
      "C4800" # 'int' : forcing value to bool 'true' or 'false'
              # (performance warning)
      "C4820" # 'bytes' bytes padding added after construct 'member_name'
      "C5027" # move assignment operator was implicitly defined as deleted
      "C5045" # compiler will insert Spectre mitigation for memory load
              # if /Qspectre switch specified
      )
  set(MSVC_LEVEL4_WARNINGS_LIST
      # See https://connect.microsoft.com/VisualStudio/feedback/details/1217660/warning-c4265-when-using-functional-header
      "C4265" # class has virtual functions, but destructor is not virtual
      )
  string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR
                            ${MSVC_DISABLED_WARNINGS_LIST})
  string(REPLACE "C" " -w4" MSVC_LEVEL4_WARNINGS_STR
                            ${MSVC_LEVEL4_WARNINGS_LIST})
  set(CMAKE_C_FLAGS   "-Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
  set(CMAKE_CXX_FLAGS "-Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
  add_definitions(-D_HAS_EXCEPTIONS=0)
  add_definitions(-DWIN32_LEAN_AND_MEAN)
  add_definitions(-DNOMINMAX)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS) # Allow use of fopen
endif()

if((CMAKE_COMPILER_IS_GNUCXX AND CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.7.99") OR
   CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  if ((CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.8.99") OR
      CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
  endif()
endif()

# pthread_rwlock_t requires a feature flag.
if(NOT WIN32)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_XOPEN_SOURCE=700")
endif()

if(FUZZ)
  if(!CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message("You need to build with Clang for fuzzing to work")
  endif()

  add_definitions(-DBORINGSSL_UNSAFE_FUZZER_MODE)
  set(RUNNER_ARGS "-fuzzer")

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fsanitize-coverage=edge,indirect-calls,8bit-counters")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-coverage=edge,indirect-calls,8bit-counters")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  link_directories(.)
endif()

add_definitions(-DBORINGSSL_IMPLEMENTATION)

if (BUILD_SHARED_LIBS)
  add_definitions(-DBORINGSSL_SHARED_LIBRARY)
  # Enable position-independent code globally. This is needed because
  # some library targets are OBJECT libraries.
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
  set(ARCH "x86_64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "amd64")
  set(ARCH "x86_64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
  # cmake reports AMD64 on Windows, but we might be building for 32-bit.
  if (CMAKE_CL_64)
    set(ARCH "x86_64")
  else()
    set(ARCH "x86")
  endif()
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i386")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i686")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv5te")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv6")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv7-a")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
  set(ARCH "aarch64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "s390x")
  set(ARCH "s390x")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "powerpc")
  set(ARCH "powerpc")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "riscv32")
  set(ARCH "riscv32")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "riscv64")
  set(ARCH "riscv64")
else()
  message(FATAL_ERROR "Unknown processor:" ${CMAKE_SYSTEM_PROCESSOR})
endif()

if (ANDROID AND ${ARCH} STREQUAL "arm")
  # The Android-NDK CMake files somehow fail to set the -march flag for
  # assembly files. Without this flag, the compiler believes that it's
  # building for ARMv5.
  if (NOT OPENSSL_NO_ASM)
    set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -march=${CMAKE_SYSTEM_PROCESSOR}")
  endif()
endif()

# if (${ARCH} STREQUAL "x86" AND APPLE)
  # With CMake 2.8.x, ${CMAKE_SYSTEM_PROCESSOR} evalutes to i386 on OS X,
  # but clang defaults to 64-bit builds on OS X unless otherwise told.
  # Set ARCH to x86_64 so clang and CMake agree. This is fixed in CMake 3.
#  set(ARCH "x86_64")
#endif()

if (OPENSSL_NO_ASM)
  add_definitions(-DOPENSSL_NO_ASM)
  set(ARCH "generic")
endif()

# Declare a dummy target to build all unit tests. Test targets should inject
# themselves as dependencies next to the target definition.
if(ENABLE_TESTS)
add_custom_target(all_tests)
endif()

add_subdirectory(crypto)
add_subdirectory(ssl)
if(ENABLE_TESTS)
add_subdirectory(ssl/test)
endif()
if(ENABLE_TOOL)
add_subdirectory(tool)
endif()
if(ENABLE_DECREPIT)
add_subdirectory(decrepit)
endif()

if(FUZZ)
  add_subdirectory(fuzz)
endif()

if (NOT ${CMAKE_VERSION} VERSION_LESS "3.2")
  # USES_TERMINAL is only available in CMake 3.2 or later.
  set(MAYBE_USES_TERMINAL USES_TERMINAL)
endif()

set (
	BORINGSSL_OBJECTS
	$<TARGET_OBJECTS:crypto-objects>
	${crypto_objects_dependencies}
	$<TARGET_OBJECTS:ssl-objects>
	${ssl_objects_dependencies}
	PARENT_SCOPE
)

# add_custom_target(
#     run_tests
#     COMMAND ${GO_EXECUTABLE} run util/all_tests.go -build-dir
#             ${CMAKE_BINARY_DIR}
#     COMMAND cd ssl/test/runner
#     COMMAND ${GO_EXECUTABLE} test -shim-path $<TARGET_FILE:bssl_shim>
#     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
#     DEPENDS all_tests bssl_shim
#     ${MAYBE_USES_TERMINAL})

=== mcs/class/Makefile ===
thisdir = class

NO_FACADES_PROFILE := $(filter monodroid_tools monotouch_tools wasm_tools binary_reference_assemblies xbuild_12 xbuild_14 netcore, $(PROFILE))

ifndef NO_FACADES_PROFILE
FACADES_FOLDER := Facades
endif

-include ../build/config.make

ifdef MCS_MODE
MCS_MODE_dirs := Mono.Cecil.Mdb
endif

# Tooling dependencies of mscorlib, we build them to /tmp folder for MONO_PATH to work
# reliably for clean and update builds. All deps are built against stable API to run with
# range of boostrap versions and .NET at the same time
build_SUBDIRS = \
	Mono.Cecil \
	$(MCS_MODE_dirs) \
	../tools/cil-stringreplacer \
	PEAPI \
	../ilasm \
	corlib

build_PARALLEL_SUBDIRS = \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	Mono.Posix \
	System.Core \
	System.Configuration \
	System.ComponentModel.Composition.4.5 \
	System.Numerics \
	System.Xml.Linq \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.Net.Http \
	System.Net.Http.WebRequest \
	System.Drawing

ifdef MCS_MODE

build_SUBDIRS += \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	Mono.Posix \
	System.Core \
	Mono.CompilerServices.SymbolWriter

build_PARALLEL_SUBDIRS += ../mcs
endif

mobile_common_dirs := \
	corlib

mobile_common_dirs_parallel := \
	Mono.Security \
	System	\
	System.Core	\
	System.XML	\
	System.Security	\
	I18N		\
	System.ServiceModel.Internals	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	System.IdentityModel		\
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Web.Services	\
	Mono.Data.Tds	\
	System.Transactions	\
	System.Numerics	\
	System.Numerics.Vectors		\
	System.Data	\
	System.Data.DataSetExtensions \
	Mono.Data.Sqlite	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.DataAnnotations \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Net.Http	\
	System.Windows \
	System.Xml.Serialization \
	Microsoft.CSharp \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler \
	System.Runtime.CompilerServices.Unsafe

testing_aot_full_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd \
	Mono.CSharp

testing_aot_full_interp_dirs_parallel := $(testing_aot_full_dirs_parallel)

testing_aot_hybrid_dirs_parallel := $(testing_aot_full_dirs_parallel)

xammac_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.CompilerServices.SymbolWriter	\
	Mono.CSharp

monodroid_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.CompilerServices.SymbolWriter	\
	Mono.Btls.Interface	\
	Mono.Posix \
	Mono.CSharp \
	Mono.Debugger.Soft \
	Mono.Runtime.Tests

monodroid_tools_dirs_parallel := \
	Mono.Cecil	\
	Mono.Cecil.Mdb	\
	Mono.CompilerServices.SymbolWriter \
	ICSharpCode.SharpZipLib	\
	monodoc \
	Mono.Debugger.Soft \
	Mono.Profiler.Log

monotouch_tools_dirs_parallel := \
	Mono.Cecil \
	Mono.Cecil.Mdb

monotouch_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd \
	Mono.CSharp \
	Mono.Runtime.Tests

monotouch_watch_dirs_parallel := $(filter-out Mono.Security Mono.Data.Tds,$(monotouch_dirs_parallel))

monotouch_runtime_dirs_parallel := \
	Mono.Security \
	System \
	System.Core \
	System.XML \
	Mono.CSharp

monotouch_tv_dirs_parallel := $(monotouch_dirs_parallel)

monotouch_tv_runtime_dirs_parallel := $(monotouch_runtime_dirs_parallel)

monotouch_watch_runtime_dirs_parallel := \
	System \
	System.Core \
	System.XML \
	Mono.CSharp

monotouch_tv_runtime_dirs := \
	Mono.Security \
	$(monotouch_watch_runtime_dirs_parallel)

winaot_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd

testing_winaot_interp_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd

unreal_dirs_parallel := \
	$(mobile_common_dirs_parallel)

wasm_dirs_parallel := \
	Mono.Security \
	System	\
	System.Core	\
	System.XML	\
	System.Security	\
	I18N		\
	System.Transactions	\
	System.ServiceModel.Internals	\
	System.Runtime.Serialization	\
	System.Data	\
	System.Data.DataSetExtensions	\
	System.Xml.Linq	\
	System.Numerics	\
	System.Numerics.Vectors		\
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.DataAnnotations \
	System.ComponentModel.Composition.4.5 \
	System.Net.Http	\
	Microsoft.CSharp \
	System.Runtime.CompilerServices.Unsafe

wasm_tools_dirs_parallel := \
	Mono.Cecil

orbis_dirs_parallel := \
	$(filter-out Microsoft.CSharp Mono.Data.Sqlite,$(mobile_common_dirs_parallel))

xammac_4_5_dirs_parallel := \
	Mono.Security \
	System	\
	System.XML			\
	System.Security			\
	Mono.Posix	\
	System.Core	\
	System.Configuration	\
	I18N		\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Numerics	\
	System.Numerics.Vectors		\
	Mono.Data.Tds	\
	System.Transactions	\
	System.EnterpriseServices	\
	System.Data	\
	System.Data.DataSetExtensions	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	Mono.Data.Sqlite	\
	System.Runtime.Serialization.Formatters.Soap \
	System.ComponentModel.DataAnnotations \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	Mono.Messaging			\
	System.Configuration.Install 	\
	System.Messaging	        \
	System.Web.Services \
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Windows \
	System.Xml.Serialization \
	Mono.CSharp	\
	Microsoft.CSharp \
	Mono.CompilerServices.SymbolWriter	\
	System.Data.Linq		\
	System.Net.Http \
	System.Net.Http.WebRequest \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler	\
	System.Runtime.CompilerServices.Unsafe

# Could be just mscorlib but we have unhandled dependency from RabbitMQ.Client.Apigen.exe
net_4_x_dirs := \
	corlib \
	Mono.Security \
	System	\
	System.XML

net_4_x_parallel_dirs = \
	System.Security			\
	Mono.Posix			\
	System.Core			\
	System.Configuration	\
	System.Drawing			\
	System.IO.Compression 		\
	System.IO.Compression.FileSystem \
	System.Transactions		\
	System.EnterpriseServices	\
	System.Numerics		\
	System.Numerics.Vectors		\
	System.Data		\
	System.ComponentModel.DataAnnotations	\
	Accessibility			\
	Mono.WebBrowser			\
	System.Runtime.Serialization.Formatters.Soap \
	System.Windows.Forms		\
	Mono.Data.Sqlite		\
	System.Web.ApplicationServices	\
	Novell.Directory.Ldap		\
	System.DirectoryServices	\
	System.Design			\
	System.Web.Services		\
	System.Web			\
	System.Runtime.Remoting		\
	System.Configuration.Install 	\
	System.Management		\
	System.Data.OracleClient	\
	Commons.Xml.Relaxng		\
	Mono.Messaging			\
	System.Messaging	        \
	System.ServiceProcess           \
	System.Drawing.Design		\
	ICSharpCode.SharpZipLib		\
	Microsoft.CSharp	\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Runtime.Serialization	\
	System.Xml.Linq			\
	System.Data.Linq		\
	System.Web.Abstractions		\
	System.Web.Routing		\
	System.Runtime.DurableInstancing \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	System.ServiceModel		\
	System.Web.Extensions		\
	System.Web.Extensions.Design	\
	System.Web.DynamicData		\
	System.Net			\
	System.Xaml \
	WindowsBase \
	System.ServiceModel.Activation \
	System.ServiceModel.Routing \
	System.ServiceModel.Discovery \
	System.Runtime.Caching \
	Microsoft.Web.Infrastructure \
	System.ServiceModel.Web \
	System.Net.Http	\
	System.Net.Http.WebRequest \
	System.Web.Razor \
	System.Web.WebPages.Deployment \
	System.Web.WebPages \
	System.Web.WebPages.Razor \
	System.Web.Mvc3 \
	System.Net.Http.Formatting \
	System.Web.Http \
	System.Web.Http.SelfHost \
	System.Web.Http.WebHost \
	CustomMarshalers		\
	IBM.Data.DB2			\
	PEAPI				\
	I18N				\
	Cscompmgd			\
	Mono.CompilerServices.SymbolWriter \
	Mono.Btls.Interface		\
	Mono.Http			\
	Mono.Cairo                      \
	Mono.Cecil			\
	Mono.Cecil.Mdb			\
	Mono.CSharp			\
	Mono.Debugger.Soft		\
	Mono.C5				\
	Mono.Management			\
	Mono.Options 			\
	Mono.Simd			\
	Mono.Tasklets       		\
	Mono.CodeContracts \
	Mono.Parallel \
	Mono.Security.Win32		\
	Mono.Messaging.RabbitMQ		\
	Mono.Data.Tds			\
	System.Dynamic			\
	System.Windows.Forms.DataVisualization	\
	System.Reactive.Interfaces \
	System.Reactive.Core \
	System.Reactive.Linq \
	System.Reactive.PlatformServices \
	System.Reactive.Providers \
	System.Reactive.Runtime.Remoting \
	System.Reactive.Windows.Forms \
	System.Reactive.Windows.Threading \
	System.Reactive.Observable.Aliases \
	System.Reactive.Experimental \
	System.Reactive.Debugger \
	System.Data.Services.Client	\
	System.Data.Services \
	System.Data.Entity \
	System.Data.DataSetExtensions	\
	System.Json		\
	System.Json.Microsoft \
	System.Threading.Tasks.Dataflow \
	System.ComponentModel.Composition.4.5 \
	System.Windows \
	System.Xml.Serialization \
	System.DirectoryServices.Protocols	\
	RabbitMQ.Client			\
	Microsoft.VisualC		\
	WebMatrix.Data \
	monodoc	\
	System.Deployment \
	System.Web.Mobile \
	System.Web.RegularExpressions \
	System.Workflow.Activities \
	System.Workflow.ComponentModel \
	System.Workflow.Runtime \
	System.Reflection.Context \
	Mono.Profiler.Log	\
	Mono.Runtime.Tests	\
	System.Runtime.CompilerServices.Unsafe \
	legacy/Mono.Cecil \
	SystemWebTestShim \
	$(xbuild_4_0_dirs)

xbuild_4_0_dirs := \
	Microsoft.Build.Framework	\
	Microsoft.Build.Utilities	\
	Microsoft.Build.Engine		\
	Mono.XBuild.Tasks		\
	Microsoft.Build.Tasks	\
	Microsoft.Build

monodroid_SUBDIRS := $(mobile_common_dirs)
monodroid_PARALLEL_SUBDIRS := $(monodroid_dirs_parallel)
monodroid_tools_SUBDIRS := 
monodroid_tools_PARALLEL_SUBDIRS := $(monodroid_tools_dirs_parallel)

monotouch_SUBDIRS := $(mobile_common_dirs)
monotouch_PARALLEL_SUBDIRS := $(monotouch_dirs_parallel)
monotouch_watch_SUBDIRS := $(mobile_common_dirs)
monotouch_watch_PARALLEL_SUBDIRS := $(monotouch_watch_dirs_parallel)
monotouch_tv_SUBDIRS    := $(mobile_common_dirs)
monotouch_tv_PARALLEL_SUBDIRS := $(monotouch_tv_dirs_parallel)
monotouch_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_runtime_PARALLEL_SUBDIRS := $(monotouch_runtime_dirs_parallel)
monotouch_watch_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_watch_runtime_PARALLEL_SUBDIRS := $(monotouch_watch_runtime_dirs_parallel)
monotouch_tv_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_tv_runtime_PARALLEL_SUBDIRS := $(monotouch_tv_runtime_dirs_parallel)
monotouch_tools_SUBDIRS :=
monotouch_tools_PARALLEL_SUBDIRS := $(monotouch_tools_dirs_parallel)

testing_aot_full_interp_SUBDIRS := $(mobile_common_dirs)
testing_aot_full_interp_PARALLEL_SUBDIRS := $(testing_aot_full_interp_dirs_parallel)
testing_aot_full_SUBDIRS := $(mobile_common_dirs)
testing_aot_full_PARALLEL_SUBDIRS := $(testing_aot_full_dirs_parallel)
testing_aot_hybrid_SUBDIRS := $(mobile_common_dirs)
testing_aot_hybrid_PARALLEL_SUBDIRS := $(testing_aot_hybrid_dirs_parallel)

xammac_SUBDIRS := $(mobile_common_dirs)
xammac_PARALLEL_SUBDIRS := $(xammac_dirs_parallel)
xammac_net_4_5_SUBDIRS := $(mobile_common_dirs)
xammac_net_4_5_PARALLEL_SUBDIRS := $(xammac_4_5_dirs_parallel)

binary_reference_assemblies_SUBDIRS := reference-assemblies
net_4_x_SUBDIRS := $(net_4_x_dirs)
net_4_x_PARALLEL_SUBDIRS := $(net_4_x_parallel_dirs)
xbuild_12_SUBDIRS := $(xbuild_4_0_dirs)
xbuild_14_SUBDIRS := $(xbuild_4_0_dirs) Microsoft.NuGet.Build.Tasks

winaot_SUBDIRS := $(mobile_common_dirs)
winaot_PARALLEL_SUBDIRS := $(winaot_dirs_parallel)

testing_winaot_interp_SUBDIRS := $(mobile_common_dirs)
testing_winaot_interp_PARALLEL_SUBDIRS := $(testing_winaot_interp_dirs_parallel)

orbis_SUBDIRS := $(mobile_common_dirs)
orbis_PARALLEL_SUBDIRS := $(orbis_dirs_parallel)

unreal_SUBDIRS := $(mobile_common_dirs)
unreal_PARALLEL_SUBDIRS := $(unreal_dirs_parallel)

wasm_SUBDIRS := $(mobile_common_dirs)
wasm_PARALLEL_SUBDIRS := $(wasm_dirs_parallel)
wasm_tools_SUBDIRS :=
wasm_tools_PARALLEL_SUBDIRS := $(wasm_tools_dirs_parallel)

netcore_SUBDIRS :=
netcore_PARALLEL_SUBDIRS :=

include ../build/rules.make

=== mcs/jay/Makefile ===
thisdir := jay
SUBDIRS := 
include ../build/rules.make

LOCAL_CFLAGS = -DSKEL_DIRECTORY=\""$(prefix)/share/jay"\"
NO_INSTALL = yes

sources = closure.c error.c lalr.c lr0.c main.c mkpar.c output.c reader.c \
          symtab.c verbose.c warshall.c

datafiles = ACKNOWLEDGEMENTS NEW_FEATURES NOTES README README.jay skeleton \
            skeleton.cs

DISTFILES = $(datafiles) $(sources) jay.1 $(wildcard *.h) jay.vcxproj

all-local: jay

install-local:
uninstall-local:

ifndef NO_INSTALL
install-local: jay
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/bin
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/share/jay
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/share/man/man1
	$(INSTALL_BIN) jay $(DESTDIR)$(prefix)/bin
	for datafile in $(datafiles) ; do \
	   $(INSTALL_DATA) $$datafile $(DESTDIR)$(prefix)/share/jay ; \
	done
	$(INSTALL_DATA) jay.1 $(DESTDIR)$(prefix)/share/man/man1

uninstall-local:
	-rm -f $(DESTDIR)$(prefix)/bin/jay
	for datafile in $(datafiles) ; do \
	   rm -f $(DESTDIR)$(prefix)/share/jay/$$datafile || : ; \
	done
	-rm -f $(DESTDIR)$(prefix)/share/man/man1/jay.1
endif

csproj-local:

clean-local:
	rm -f jay *.o *.exe *.pdb

dist-local: dist-default

test-local run-test-local run-test-ondotnet-local doc-update-local:

ifndef ENABLE_MSVC_ONLY

jay: $(sources:.c=.o)
	$(CCOMPILE) $(LDFLAGS) -o $@ $^

%.o: %.c
	$(CCOMPILE) $(JAY_CFLAGS) -c -o $@ $^

else # !ENABLE_MSVC_ONLY

jay:
	make -C $(topdir)/../msvc jay

endif # !ENABLE_MSVC_ONLY

=== mcs/mcs/Makefile ===
# To produce a debugging parser, use the version that says "-cvt"
JAY_FLAGS=-c
# JAY_FLAGS=-cvt

thisdir := mcs
SUBDIRS := 
include ../build/rules.make

PROGRAM = mcs.exe

EXTRA_DISTFILES = \
	mcs.csproj		\
	mcs.sln		\
	cs-parser.jay		\
	mcs.exe.sources

LIB_REFS = System.Core System.Xml System
LOCAL_MCS_FLAGS += -d:STATIC,NO_SYMBOL_WRITER,NO_AUTHENTICODE

ifndef NO_THREAD_ABORT
REFERENCE_SOURCES_FLAGS += -d:MONO_FEATURE_THREAD_ABORT
endif

ifndef NO_PROCESS_START
REFERENCE_SOURCES_FLAGS += -d:MONO_FEATURE_PROCESS_START
endif

LOCAL_MCS_FLAGS += $(REFERENCE_SOURCES_FLAGS)

BUILT_SOURCES = cs-parser.cs

CLEAN_FILES += y.output

%-parser.cs: %-parser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay $(JAY_FLAGS) -o jay-tmp.out $< < $(topdir)/jay/skeleton.cs && mv jay-tmp.out $@

KEEP_OUTPUT_FILE_COPY = yes

include ../build/executable.make

#
# Below this line we have local targets used for testing and development
#

# Testing targets

TIME = time

# This used to be called test, but that conflicts with the global
# recursive target.

btest: mcs2.exe mcs3.exe
	ls -l mcs2.exe mcs3.exe

mcs2.exe: $(PROGRAM)
	$(TIME) $(RUNTIME) $(RUNTIME_FLAGS) $(PROGRAM) $(USE_MCS_FLAGS) $(MCS_REFERENCES) -target:exe -out:$@ $(BUILT_SOURCES) $(EXTRA_SOURCES) @$(response)

mcs3.exe: mcs2.exe
	$(TIME) $(RUNTIME) $(RUNTIME_FLAGS) ./mcs2.exe $(USE_MCS_FLAGS) $(MCS_REFERENCES) -target:exe -out:$@ $(BUILT_SOURCES) $(EXTRA_SOURCES) @$(response)

wc:
	wc -l $(BUILT_SOURCES) `cat $(sourcefile)`

# we need this because bash tries to use its own crappy timer
FRIENDLY_TIME = $(shell which time) -f'%U seconds'

do-time : $(PROGRAM)
	@ echo -n "Run 1:   "
	@ rm -f mcs2.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs2.exe > /dev/null || (echo FAILED; exit 1)
	@ echo -n "Run 2:   "
	@ rm -f mcs3.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs3.exe > /dev/null || (echo FAILED; exit 1)
	@ $(MAKE) do-corlib

do-corlib:
	@ echo -n "corlib:  "
	@ rm -f ../class/lib/mscorlib.dll
	@ cd ../class/corlib ; $(MAKE) BOOTSTRAP_MCS='$(FRIENDLY_TIME) mono $$(topdir)/class/lib/$(PROFILE)/mcs.exe' > /dev/null || (echo FAILED; exit 1)

PROFILER=default

do-gettext:
	xgettext --keyword='Report.Error:3' --keyword='Report.Error:2' --keyword='Report.Warning:3' --keyword='Report.Warning:2' -o mcs.po --language='C#' `cat gmcs.exe.sources | grep -v /`

profile : $(PROGRAM)
	$(RUNTIME) $(RUNTIME_FLAGS) --profile=$(PROFILER) $(PROGRAM) $(USE_MCS_FLAGS) -target:exe -out:mcs2.exe $(BUILT_SOURCES) @$(response)

debug-parser:
	rm cs-parser.cs
	$(MAKE) JAY_FLAGS=-cvt

#
# quick hack target, to quickly develop the gmcs compiler
# Update manually.

q: cs-parser.cs qh
	echo 'System.Console.WriteLine ("Hello");' | mono csharp.exe
	echo -e 'using System;\nConsole.WriteLine ("hello");' | mono csharp.exe
	echo -e '"foo" == "bar";' | mono csharp.exe
	echo -e 'var a = 1;\na + 2;' | mono csharp.exe
	echo -e 'int j;\nj = 1;' | mono csharp.exe
	echo -e 'var a = new int[]{1,2,3};\nfrom x in a select x;' | mono csharp.exe
	echo -e 'var a = from f in System.IO.Directory.GetFiles ("/tmp") where f == "passwd" select f;' | mono csharp.exe

=== external/binary-reference-assemblies/v4.7/Makefile ===
PROFILE := v4.7
SOURCEDIR := ../src/$(PROFILE)/

CSC ?= csc
CSC_COMMON_ARGS := -nologo -noconfig -optimize -nostdlib -unsafe -deterministic -publicsign -debug- -target:library -nowarn:612 -nowarn:618
Q_CSC = $(if $(V),,@echo "CSC   [$(PROFILE)] $(1)";)

ASSEMBLIES := Accessibility CustomMarshalers	\
	Microsoft.Build.Engine Microsoft.Build.Framework Microsoft.Build.Tasks.v4.0	\
	Microsoft.Build.Utilities.v4.0 Microsoft.Build Microsoft.CSharp Microsoft.VisualBasic Microsoft.VisualC	\
	System.ComponentModel.Composition	\
	System.ComponentModel.DataAnnotations System.Configuration.Install System.Configuration System.Core	\
	System.Data.DataSetExtensions System.Data.Entity System.Data.Linq System.Data.OracleClient	\
	System.Data.Services.Client System.Data.Services System.Data System.Design System.DirectoryServices.Protocols	\
	System.DirectoryServices System.Drawing.Design System.Drawing System.Dynamic System.EnterpriseServices	\
	System.IO.Compression.FileSystem System.IO.Compression System.IdentityModel.Selectors System.IdentityModel	\
	System.Management System.Messaging	\
	System.Net.Http.WebRequest System.Net.Http System.Net System.Numerics	\
	System.Runtime.Caching System.Runtime.DurableInstancing System.Runtime.Remoting	\
	System.Runtime.Serialization.Formatters.Soap System.Runtime.Serialization System.Security System.ServiceModel.Activation	\
	System.ServiceModel.Discovery System.ServiceModel.Internals System.ServiceModel.Routing System.ServiceModel.Web	\
	System.ServiceModel System.ServiceProcess System.Transactions System.Web.Abstractions	\
	System.Web.ApplicationServices System.Web.DynamicData System.Web.Extensions.Design System.Web.Extensions	\
	System.Web.Routing System.Web.Services System.Web	\
	System.Windows.Forms.DataVisualization System.Windows.Forms System.Windows System.Xaml System.Xml.Linq	\
	System.Xml.Serialization System.Xml System WindowsBase mscorlib	\
	System.Deployment System.Reflection.Context System.Runtime.InteropServices.RuntimeInformation	\
	System.Web.Mobile System.Web.RegularExpressions System.Workflow.Activities System.Workflow.ComponentModel System.Workflow.Runtime

ASSEMBLIES += bare/System bare/System.Xml bare/System.Configuration bare/System.ServiceModel.Activation bare/System.Web

FACADE_ASSEMBLIES := Facades/System.Collections.Concurrent Facades/System.Net.Primitives Facades/System.Runtime	\
	Facades/System.Collections Facades/System.Net.Requests Facades/System.Security.Principal	\
	Facades/System.ComponentModel.Annotations Facades/System.ObjectModel Facades/System.ServiceModel.Duplex	\
	Facades/System.ComponentModel.EventBasedAsync Facades/System.Reflection.Emit.ILGeneration Facades/System.ServiceModel.Http	\
	Facades/System.ComponentModel Facades/System.Reflection.Emit.Lightweight Facades/System.ServiceModel.NetTcp	\
	Facades/System.Diagnostics.Contracts Facades/System.Reflection.Emit Facades/System.ServiceModel.Primitives	\
	Facades/System.Diagnostics.Debug Facades/System.Reflection.Extensions Facades/System.ServiceModel.Security	\
	Facades/System.Diagnostics.Tools Facades/System.Reflection.Primitives Facades/System.Text.Encoding.Extensions	\
	Facades/System.Diagnostics.Tracing Facades/System.Reflection Facades/System.Text.Encoding	\
	Facades/System.Dynamic.Runtime Facades/System.Resources.ResourceManager Facades/System.Text.RegularExpressions	\
	Facades/System.Globalization Facades/System.Runtime.Extensions Facades/System.Threading.Tasks.Parallel	\
	Facades/System.IO Facades/System.Runtime.InteropServices.WindowsRuntime Facades/System.Threading.Tasks	\
	Facades/System.Linq.Expressions Facades/System.Runtime.InteropServices Facades/System.Threading.Timer	\
	Facades/System.Linq.Parallel Facades/System.Runtime.Numerics Facades/System.Threading	\
	Facades/System.Linq.Queryable Facades/System.Runtime.Serialization.Json Facades/System.Xml.ReaderWriter	\
	Facades/System.Linq Facades/System.Runtime.Serialization.Primitives Facades/System.Xml.XDocument	\
	Facades/System.Net.NetworkInformation Facades/System.Runtime.Serialization.Xml Facades/System.Xml.XmlSerializer	\
	Facades/System.Net.WebHeaderCollection Facades/System.Runtime.Handles

ASSEMBLIES += $(FACADE_ASSEMBLIES)

# generated with (and then slightly tweaked):
# for i in *.dll; do ikdasm --assemblyref $i | grep Name= | sed 's/.*Name=//g' | sed -e $'s/$/\\\n/g' | sed -e ':a' -e 'N' -e '$!ba' -e 's/\n/ /g' -e "s/^/${i%.*}_REFS := /"; done
Accessibility_REFS := mscorlib
CustomMarshalers_REFS := mscorlib
Microsoft.Build.Engine_REFS := mscorlib System.Xml Microsoft.Build.Framework Microsoft.Build.Utilities.v4.0 System System.Core
Microsoft.Build.Framework_REFS := mscorlib System
Microsoft.Build.Tasks.v4.0_REFS := mscorlib Microsoft.Build.Framework Microsoft.Build.Utilities.v4.0 System Microsoft.Build.Engine System.Xml System.Core
Microsoft.Build.Utilities.v4.0_REFS := mscorlib Microsoft.Build.Framework System System.Xml
Microsoft.Build_REFS := mscorlib Microsoft.Build.Framework System.Xml System System.Core
Microsoft.CSharp_REFS := mscorlib System System.Core
Microsoft.VisualBasic_REFS := mscorlib System System.Windows.Forms System.Drawing
Microsoft.VisualC_REFS := mscorlib
System.ComponentModel.Composition_REFS := mscorlib System System.Core
System.ComponentModel.DataAnnotations_REFS := mscorlib System System.Core
System.Configuration.Install_REFS := mscorlib System
System.Configuration_REFS := mscorlib bare/System.Xml System
System.Core_REFS := mscorlib System
System.Data.DataSetExtensions_REFS := mscorlib System.Data System System.Core
System.Data.Entity_REFS := mscorlib System.Core System System.Data System.Runtime.Serialization System.ComponentModel.DataAnnotations System.Xml System.Xml.Linq System.Transactions System.Configuration
System.Data.Linq_REFS := mscorlib System.Data System.Core System System.Xml System.Runtime.Serialization
System.Data.OracleClient_REFS := mscorlib System.Data System System.Drawing System.EnterpriseServices System.Transactions
System.Data.Services.Client_REFS := mscorlib System System.Xml System.Core System.Xml.Linq
System.Data.Services_REFS := mscorlib System.Configuration System.ServiceModel System.ServiceModel.Web System System.ServiceModel.Activation System.Core System.Data.Services.Client
System.Data_REFS := mscorlib System.Configuration System.Xml System System.Numerics System.Core System.Transactions System.EnterpriseServices
System.Deployment_REFS := mscorlib
System.Design_REFS := mscorlib System.Drawing System.Drawing.Design System System.Windows.Forms System.Data bare/System.Web System.Configuration System.Xml
System.DirectoryServices.Protocols_REFS := mscorlib System.Xml System System.DirectoryServices
System.DirectoryServices_REFS := mscorlib System
System.Drawing.Design_REFS := mscorlib System.Drawing System.Windows.Forms System
System.Drawing_REFS := mscorlib System
System.Dynamic_REFS := mscorlib System.Core System
System.EnterpriseServices_REFS := mscorlib System.Transactions
System.IO.Compression.FileSystem_REFS := mscorlib System.IO.Compression System
System.IO.Compression_REFS := mscorlib System
System.IdentityModel.Selectors_REFS := mscorlib System.Xml System System.IdentityModel
System.IdentityModel_REFS := mscorlib System.Configuration System.Runtime.Serialization System.Security System System.Xml System.Web.ApplicationServices
System.Management_REFS := mscorlib System System.Configuration.Install
System.Messaging_REFS := mscorlib System System.Drawing System.Configuration.Install System.Xml System.Windows.Forms
System.Net.Http.WebRequest_REFS := mscorlib System.Net.Http System
System.Net.Http_REFS := mscorlib System System.Core
System.Net_REFS := mscorlib System
System.Numerics_REFS := mscorlib
System.Reflection.Context_REFS := mscorlib
System.Reflection.Metadata_REFS := System.Runtime System.Resources.ResourceManager System.Collections.Immutable System.Reflection.Primitives System.Diagnostics.Debug System.Collections System.IO System.IO.Compression System.Text.Encoding System.Runtime.InteropServices System.Linq System.Reflection System.Threading System.Runtime.Extensions System.Text.Encoding.Extensions System.Reflection.Extensions
System.Runtime.Caching_REFS := mscorlib System System.Data System.Configuration
System.Runtime.DurableInstancing_REFS := mscorlib System.Xml.Linq System.ServiceModel.Internals System.Transactions System.Core System.Runtime.Serialization System
System.Runtime.InteropServices.RuntimeInformation_REFS := mscorlib
System.Runtime.Remoting_REFS := mscorlib System System.Web System.Xml System.Runtime.Serialization.Formatters.Soap
System.Runtime.Serialization.Formatters.Soap_REFS := mscorlib System.Xml
System.Runtime.Serialization_REFS := mscorlib System.Xml System.ServiceModel.Internals System System.Configuration System.Core
System.Security_REFS := mscorlib System System.Xml
System.ServiceModel.Activation_REFS := mscorlib System.ServiceModel System System.Web
System.ServiceModel.Discovery_REFS := mscorlib System.ServiceModel System System.Xml System.Xml.Linq System.Runtime.Serialization System.Configuration System.Core
System.ServiceModel.Internals_REFS := mscorlib System System.Xml
System.ServiceModel.Routing_REFS := mscorlib System.ServiceModel System.Configuration System System.Runtime.Serialization
System.ServiceModel.Web_REFS := mscorlib System.ServiceModel System System.Runtime.Serialization System.Xml System.Xml.Linq System.Configuration System.ServiceModel.Activation System.Core System.Web.Extensions
System.ServiceModel_REFS := mscorlib System.Xml System.Xml.Linq System.Xaml System System.EnterpriseServices System.Transactions System.IdentityModel System.Runtime.Serialization System.Runtime.DurableInstancing System.Security System.Web.ApplicationServices System.Messaging System.Net.Http System.IdentityModel.Selectors System.Web.Services System.Configuration System.Web System.Core bare/System.ServiceModel.Activation
System.ServiceProcess_REFS := mscorlib System System.Configuration.Install System.Windows.Forms
System.Transactions_REFS := mscorlib System.Configuration
System.Web.Abstractions_REFS := mscorlib System.Web
System.Web.ApplicationServices_REFS := mscorlib System System.Configuration
System.Web.DynamicData_REFS := mscorlib System System.Drawing System.Web System.Web.Extensions System.Core System.ComponentModel.DataAnnotations System.Data.Linq
System.Web.Extensions.Design_REFS := mscorlib System System.Design System.Drawing System.Web.Extensions
System.Web.Extensions_REFS := mscorlib System.Web System System.Xml System.Drawing System.Design System.Data.Linq System.Web.Services System.ServiceModel System.ServiceModel.Activation System.Runtime.Serialization System.Web.ApplicationServices System.Core System.Configuration
System.Web.Mobile_REFS := mscorlib
System.Web.RegularExpressions_REFS := mscorlib System
System.Web.Routing_REFS := mscorlib System.Web
System.Web.Services_REFS := mscorlib System System.Configuration System.EnterpriseServices System.Xml bare/System.Web System.DirectoryServices System.Design System.Data
System.Web_REFS := mscorlib System.Configuration System.Xml System System.Data System.Drawing System.Runtime.Serialization.Formatters.Soap System.Core System.EnterpriseServices System.Web.ApplicationServices System.ComponentModel.DataAnnotations System.Web.Services
System.Windows.Forms.DataVisualization_REFS := mscorlib System.Drawing System.Windows.Forms System System.Xml System.Data System.Core
System.Windows.Forms_REFS := mscorlib System System.Xml System.Drawing System.Runtime.Serialization.Formatters.Soap Accessibility System.Configuration System.Data
System.Windows_REFS := mscorlib System
System.Workflow.Activities_REFS := mscorlib
System.Workflow.ComponentModel_REFS := mscorlib
System.Workflow.Runtime_REFS := mscorlib
System.Xaml_REFS := mscorlib System System.Xml System.Core
System.Xml.Linq_REFS := mscorlib System System.Runtime.Serialization System.Xml System.Core
System.Xml.Serialization_REFS := mscorlib System.ServiceModel System.Xml

=== external/linker/monobuild/Makefile ===
MSBUILD = msbuild
CONFIGURATION = Debug

all: build check

build: prepare
	$(MSBUILD) ../monolinker.sln /p:Configuration=$(CONFIGURATION)

clean:
	$(MSBUILD) ../monolinker.sln /t:clean

prepare:
	nuget help | head -1
	nuget restore ../external/cecil/
	nuget restore ../monolinker.sln
	# The nunit runner used below seems to expect the old package layout.
	# This could potentially be removed with an update to nunit.
	nuget restore -PackagesDirectory ../packages ../test/Mono.Linker.Tests/packages.config

check: prepare
	mono ../packages/NUnit.ConsoleRunner.3.6.1/tools/nunit3-console.exe --result="TestResults.xml;format=nunit2" ../test/Mono.Linker.Tests/bin/$(CONFIGURATION)/net471/Mono.Linker.Tests.dll

=== mcs/class/Microsoft.Build.Utilities/Makefile ===
thisdir = class/Microsoft.Build.Utilities
SUBDIRS = 
include ../../build/rules.make

XBUILD_DIR=$(topdir)/tools/xbuild
include $(XBUILD_DIR)/xbuild.make

LIBRARY = Microsoft.Build.Utilities.dll
LIBRARY_NAME = Microsoft.Build.Utilities$(NAME_SUFFIX).dll

LIB_REFS = $(PARENT_PROFILE)System $(PARENT_PROFILE)System.Core $(PARENT_PROFILE)System.Xml $(XBUILD_FRAMEWORK)
KEYFILE = ../msfinal.pub
LIB_MCS_FLAGS =

TEST_RESX_RESOURCES = Test/Microsoft.Build.Utilities/Strings.resources

TEST_LIB_REFS = $(XBUILD_ENGINE) $(XBUILD_FRAMEWORK) $(PARENT_PROFILE)System $(PARENT_PROFILE)System.Core
TEST_MCS_FLAGS = $(TEST_RESX_RESOURCES:%=-resource:%)
TEST_NUNITLITE_APP_CONFIG_RUNTIME=Test/test-config-file-$(PROFILE)

include $(XBUILD_DIR)/xbuild_test.make
include ../../build/library.make

EXTRA_DISTFILES = $(TEST_RESX_RESOURCES:.resources=.resx)

CLEAN_FILES += $(TEST_RESX_RESOURCES)

.NOTPARALLEL: $(TEST_RESX_RESOURCES)

$(TEST_RESX_RESOURCES): %.resources: %.resx
	$(RESGEN) $< || cp $@.prebuilt $@

$(test_lib_output): $(TEST_RESX_RESOURCES) $(test_lib_dir)

=== mcs/class/Mono.Debugger.Soft/Makefile ===
thisdir = class/Mono.Debugger.Soft
include ../../build/rules.make

LIBRARY = Mono.Debugger.Soft.dll
LIBRARY_SNK = ../mono.snk

LIB_REFS = System Mono.Cecil System.Core
LIB_MCS_FLAGS = /unsafe -D:MONO_DATACONVERTER_STATIC_METHODS -D:ENABLE_CECIL /publicsign
KEYFILE = $(LIBRARY_SNK)

TEST_LIB_REFS = Mono.Cecil System System.Core

ifneq ($(filter monodroid monotouch monotouch_tv monotouch_watch wasm net_4_x,$(PROFILE)),)
test-local: build-dtest
endif

ifneq ($(filter monodroid monotouch monotouch_tv monotouch_watch wasm,$(PROFILE)),)
NO_INSTALL=1
NO_BUILD=1
NO_TEST=1
endif

test_output_dir=$(topdir)/class/lib/$(PROFILE)/tests

$(test_output_dir):
	mkdir -p $@

build-dtest: $(test_output_dir)/dtest-app.exe $(test_output_dir)/dtest-excfilter.exe

$(test_output_dir)/dtest-excfilter.exe: Test/dtest-excfilter.il | $(test_output_dir)
	$(ILASM) -out:$@ /exe /debug Test/dtest-excfilter.il

$(test_output_dir)/dtest-app.exe: Test/dtest-app.cs $(TEST_HELPERS_SOURCES) | $(test_output_dir)
	$(CSCOMPILE) -r:$(topdir)/class/lib/$(PROFILE)/mscorlib.dll -r:$(topdir)/class/lib/$(PROFILE)/System.Core.dll -r:$(topdir)/class/lib/$(PROFILE)/System.dll -r:$(topdir)/class/lib/$(PROFILE)/System.Runtime.CompilerServices.Unsafe.dll -sourcelink:Test/sourcelink.json -out:$@ -unsafe $(PLATFORM_DEBUG_FLAGS) -optimize- Test/dtest-app.cs $(TEST_HELPERS_SOURCES)

TEST_HELPERS_SOURCES = \
	../test-helpers/NetworkHelpers.cs \
	Test/TypeLoadClass.cs

EXTRA_DISTFILES = \
	Test/dtest-app.cs \
	Test/dtest.cs \
	Test/dtest-excfilter.il \
	Test/sourcelink.json \
	$(TEST_HELPERS_SOURCES)

CLEAN_FILES = $(addprefix $(test_output_dir)/, dtest-app.exe dtest-app.exe.mdb dtest-app.pdb dtest-excfilter.exe dtest-excfilter.exe.mdb dtest-excfilter.pdb)

include ../../build/library.make

=== mcs/class/Mono.XBuild.Tasks/Makefile ===
thisdir = class/Mono.XBuild.Tasks
SUBDIRS = 
include ../../build/rules.make

XBUILD_DIR=$(topdir)/tools/xbuild
include $(XBUILD_DIR)/xbuild.make

LIBRARY = Mono.XBuild.Tasks.dll

LIB_REFS = $(PARENT_PROFILE)System $(PARENT_PROFILE)System.Xml
KEYFILE = ../mono.pub
LIB_MCS_FLAGS =

TEST_NUNITLITE_APP_CONFIG_RUNTIME=Test/test-config-file-$(PROFILE)

include $(XBUILD_DIR)/xbuild_test.make

include ../../build/library.make

=== mcs/class/System.Configuration/Makefile ===
thisdir = class/System.Configuration
SUBDIRS =

include ../../build/rules.make

LIBRARY = System.Configuration.dll

LOCAL_MCS_FLAGS = 
LIB_REFS = System.Security System System.Xml
KEYFILE = ../msfinal.pub
LIB_MCS_FLAGS = -nowarn:618
TEST_MCS_FLAGS =
TEST_LIB_REFS = System.Xml System
TEST_NUNITLITE_APP_CONFIG_GLOBAL=Test/test-config-file
LIBRARY_WARN_AS_ERROR = yes

include ../../build/library.make

test-local:
	cp -f Test/appSettings.config $(dir $(NUNITLITE_CONFIG_FILE))/System.Configuration-appSettings.config

run-test:
	$(MAKE) -C Test/standalone

=== mcs/class/System.Data.Services/Makefile ===
thisdir = class/System.Data.Services
SUBDIRS = 
include ../../build/rules.make

LIBRARY = System.Data.Services.dll

LIB_REFS = System System.Core System.ServiceModel System.ServiceModel.Web System.Data.Services.Client
KEYFILE = ../ecma.pub
LIB_MCS_FLAGS = -d:NET_3_5

ifeq (4, $(FRAMEWORK_VERSION_MAJOR))
LIB_REFS += System.ServiceModel.Activation
endif

TEST_MCS_FLAGS =
TEST_LIB_REFS = System.ServiceModel System.Core

include ../../build/library.make

=== debian/changelog ===
mono (6.8.0.105+dfsg-3.6ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:35:26 +0000

mono (6.8.0.105+dfsg-3.6ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use -O2 to fix build on ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Mar 2024 09:44:38 +0100

mono (6.8.0.105+dfsg-3.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with -Werror=implicit-function-declaration (Closes: #1066220).

 -- Andrey Rakhmatullin <wrar@debian.org>  Fri, 15 Mar 2024 22:02:36 +0500

mono (6.8.0.105+dfsg-3.5ubuntu1) noble; urgency=medium

  * Use -O2 to fix build on ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Nov 2023 12:56:53 +0100

=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Mono Group <pkg-mono-group@lists.alioth.debian.org>
Uploaders: Mirco Bauer <meebey@debian.org>, Jo Shields <directhex@apebox.org>
Build-Depends: debhelper (>= 7),
	dpkg-dev (>= 1.16.1~),
	procps,
	python3,
	bison,
	libtool,
	libxml-dom-perl,
	libxslt1-dev,
	libkrb5-dev,
	dc,
	lsb-release,
	libx11-dev,
	libxt-dev,
	tzdata,
	cmake,
	zlib1g-dev,
	autoconf,
	automake
Standards-Version: 3.9.6
Homepage: http://www.mono-project.com/
Vcs-Git: https://salsa.debian.org/dotnet-team/mono.git
Vcs-Browser: https://salsa.debian.org/dotnet-team/mono

Package: mono-runtime-common
Provides: cli-runtime, cli-virtual-machine
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-common (<< 2.4), mono-jit (<< 2.4), libmono0 (<< 2.4), mono-runtime (<< 3.2.1)
Conflicts: mono-common (<< 2.4),
           mono-jit (<< 2.4),
           mono-1.0-runtime (<< 2.4),
           mono-2.0-runtime (<< 2.4),
           mono-runtime (<< 3.2.1)
Suggests: xdg-utils | libgnome2-0 | konqueror
Depends: ${shlibs:Depends},
         ${misc:Depends},
         binutils,
Description: Mono runtime - common files
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains common files for the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono".
 "mono" executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures. Optionally this package configures BINFMT support.

Package: mono-runtime
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-runtime-sgen (= ${binary:Version})
Recommends: binfmt-support (>= 1.1.2)
Description: Mono runtime - default version
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package installs this architecture's default runtime version.

Package: mono-runtime-sgen
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version})
Homepage: http://www.mono-project.com/Compacting_GC
Description: Mono runtime - SGen
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses SGen which is Mono's new simple generational garbage
 collector.

Package: mono-runtime-boehm
Architecture: amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mono-gac (= ${source:Version}),
         mono-runtime-common (= ${binary:Version})
Description: Mono runtime - Boehm
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the Virtual Machine, JIT (Just-in-Time) and
 AOT (Ahead-of-Time) code generator "mono-sgen".
 mono-sgen executes applications for the CLI (Common Language Infrastructure).
 Mono currently only supports the X86, PowerPC, ARM, S/390x, AMD64 and
 MIPS architectures.
 .
 This package uses Boehm's conservative garbage collector.

Package: mono-runtime-dbg
Priority: optional
Section: debug
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-jit-dbg (<< 2.4)
Conflicts: mono-jit-dbg (<< 2.4)
Depends: ${misc:Depends}, mono-runtime-sgen (= ${binary:Version}), mono-runtime-boehm (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x]
Recommends: gdb
Description: Mono runtime, debugging symbols
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package contains the debugging symbols of the Mono JIT/AOT compiler.

Package: mono-utils
Provides: cil-disassembler
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: mono-mcs (<= 1.1.6-4)
Depends: ${shlibs:Depends}, ${misc:Depends}, libmonoboehm-2.0-1 (= ${binary:Version}) [amd64 armel armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x],
 libmono-corlib4.5-cil (= ${source:Version})
Description: Mono utilities
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package includes various tools useful for CLI developers, like
 pedump, monodis and monograph.

Package: ca-certificates-mono
Architecture: all
Pre-Depends: mono-runtime-common (>= 5.20)
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}, ca-certificates (>= 20121114)
Description: Common CA certificates (Mono keystore)
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This package uses the hooks of the ca-certificates package to update the
 Mono keystore.

Package: mono-complete
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends},
         mono-runtime (= ${binary:Version}),
         mono-runtime-sgen (= ${binary:Version}),
         libmono-2.0-1 (= ${binary:Version}),
         libmono-profiler (= ${binary:Version}),
         mono-utils (= ${binary:Version}),
         mono-devel (= ${source:Version}),
         mono-mcs (= ${source:Version}),
         mono-csharp-shell (= ${source:Version}),
         mono-4.0-gac (= ${source:Version}),
         mono-4.0-service (= ${source:Version}),
         monodoc-base (= ${source:Version}),
         monodoc-manual (= ${source:Version}),
         libmono-cil-dev (= ${source:Version}),
         ca-certificates-mono (= ${source:Version})
Description: complete Mono runtime, development tools and all libraries
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.
 .
 This is a metapackage and pulls in the Mono runtime, development tools and
 all libraries.
 .
 Install this package if you want to run software for Mono or Microsoft .NET
 which you are not installing from a Debian package.
 .
 For packagers: This package is not to be used as dependency for packages!
 You should build-depend on cli-common-dev and the needed libraries instead.

Package: libmono-2.0-1
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Replaces: libmono-dev (<= 1.1.6-4)
Conflicts: mono-utils (<< 1.2.3.1-4)
Depends: ${shlibs:Depends}, ${misc:Depends}, libmonosgen-2.0-1 (= ${binary:Version})
Description: Mono JIT library (Default version)
 Shared library for Mono, used for embedding/hosting of the JIT.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmono-2.0-dev
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, libmonosgen-2.0-dev (= ${binary:Version})
Description: Mono JIT library - Development files (Default version)
 Header files and static libraries for libmono-2.0.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-1
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mono JIT library (SGen GC)
 Shared library for Mono, used for embedding/hosting of the JIT.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-1-dbg
Priority: optional
Section: debug
Architecture: amd64 armel arm64 armhf i386 mipsel kfreebsd-amd64 kfreebsd-i386 powerpc ppc64 ppc64el s390x
Depends: ${misc:Depends}, libmonosgen-2.0-1 (= ${binary:Version})
Recommends: gdb
Description: Mono JIT library, debugging symbols (SGen GC)
 This package contains the debugging symbols of the Mono JIT library.
 .
 Mono is a platform for running and developing applications based on the
 ECMA/ISO Standards. Mono is an open source effort led by Xamarin.
 Mono provides a complete CLR (Common Language Runtime) including compiler and
 runtime, which can produce and execute CIL (Common Intermediate Language)
 bytecode (aka assemblies), and a class library.

Package: libmonosgen-2.0-dev

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include debian/mono-archs.make

# Assume Debian behaviour by default.
DISTRO = $(shell lsb_release -si)

MAKEFILE = $(firstword $(MAKEFILE_LIST))
DEBIAN_DIR = $(dir $(MAKEFILE))
SOURCE_DIR = $(DEBIAN_DIR)/..

VERSION = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Vers | cut -d\  -f2)
UPVERSION = $(shell echo $(VERSION) | sed 's,-.*,,' | sed 's,+dfsg.*,,')
UPVERSION_THREEPART = $(shell echo $(UPVERSION) | cut -f1-3 -d.)
NEXT_UPVERSION = $(shell perl -e '$$_=pop; s/(\d+)$$/$$1+1/e; print' $(UPVERSION))
DEB_SOURCE_NAME = $(shell dpkg-parsechangelog -l$(DEBIAN_DIR)/changelog | grep ^Source | cut -d" " -f2)

RUN_MONO = MONO_PATH=debian/tmp/usr/lib/mono/4.5 runtime/mono-wrapper
KILL_MONO = pgrep mono | xargs kill -9
DH_INTERNAL_MONO_PARAM = --internal-mono
ifeq ($(shell dpkg --compare-versions $$(dpkg-query -f '$${Version}' -W debhelper) lt 7.1; echo $$?), 0)
	DH_INTERNAL_MONO_PARAM = internal-mono
endif

DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

ifeq ($(DEB_HOST_ARCH), ppc64el)
	export DEB_CXXFLAGS_MAINT_APPEND := -O2
	export DEB_CXXFLAGS_MAINT_STRIP := -O3
	export DEB_CFLAGS_MAINT_APPEND := -O2
	export DEB_CFLAGS_MAINT_STRIP := -O3
endif

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONF_FLAGS += --build $(DEB_HOST_GNU_TYPE)
else
	CONF_FLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	CONF_FLAGS += --enable-minimal=aot
endif

ifeq ($(DEB_HOST_ARCH), armel)
	CONF_FLAGS += --with-fpu=NONE --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), armhf)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), i386)
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), amd64)
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), mipsel)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), powerpc)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), ppc64)
	CONF_FLAGS += --with-tls=pthread
endif

ifeq ($(DEB_HOST_ARCH), ppc64el)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
endif

ifeq ($(DEB_HOST_ARCH), s390x)
	BTLS_ARCH = true
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),$(DEB_MONO_SGEN_ARCHS)))
	CONF_FLAGS += --with-sgen=yes
else
	CONF_FLAGS += --with-sgen=no
endif

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	MINI_TEST = true
	MONO_BOEHM_TEST = true
	MONO_SGEN_TEST = true
else
	TIMEOUT = timeout -k 1h 1h
	MINI_TEST = cd mono/mini && $(TIMEOUT) make check; $(KILL_MONO)
	MONO_BOEHM_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=boehm $(TIMEOUT) make check; $(KILL_MONO)
	MONO_SGEN_TEST = cd mono/tests && MONO_ENV_OPTIONS=--gc=sgen $(TIMEOUT) make check; $(KILL_MONO)
endif

ifeq ($(DEB_HOST_ARCH), arm64)
	MONO_BOEHM_TEST = true
	CONF_FLAGS += --disable-boehm
	SKIP_LIBGC = true
	BTLS_ARCH = true
endif


CONFIGURE =	CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)"   \
		$(GCC) ./configure $(CONF_FLAGS) --prefix=/usr \
		  --mandir=\$${prefix}/share/man \
		  --infodir=\$${prefix}/share/info --sysconfdir=/etc \
		  --with-ikvm-native=no \
		  --disable-quiet-build \
		  --with-csc=mcs \
		  --disable-system-aot \
		  --enable-llvm=no \
		  --enable-loadedllvm=no

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	EGLIB_MAKE_FLAGS += -j$(NUMJOBS)
	LIBGC_MAKE_FLAGS += -j$(NUMJOBS)
	MONO_MAKE_FLAGS += -j$(NUMJOBS)
endif

source: source-stamp
source-stamp:
	cd $(DEBIAN_DIR) && tar cJf mono-source.tar.xz --exclude=mono-source.tar.xz -C ../.. $$(cd ..; basename $$(pwd))
	touch $@

autoreconf: autoreconf-stamp
autoreconf-stamp: source-stamp
	autoreconf -f -i -s
	touch $@

configure: configure-stamp
configure-stamp: autoreconf-stamp
	dh_testdir
	$(CONFIGURE)
	touch $@

build: build-stamp
build-indep: build-stamp
build-arch: build-stamp
build-stamp: configure-stamp
	dh_testdir
	cd mono/eglib && $(MAKE) $(EGLIB_MAKE_FLAGS)
ifndef SKIP_LIBGC
	cd libgc && $(MAKE) $(LIBGC_MAKE_FLAGS)
endif
	cd mono && $(MAKE) $(MONO_MAKE_FLAGS)
	LC_ALL=C $(MAKE) $(MAKE_FLAGS) EXTERNAL_MCS=false EXTERNAL_MONO=false

	cd debian/detector && \
	  $(MAKE)
	chmod +x debian/dh_makeclilibs \
	         debian/dh_clideps \
	         debian/dh_clistrip \
	         debian/dh_clifixperms \
	         debian/dh_monoaot

	cp -a ./external/binary-reference-assemblies/v4.7.1 ./external/binary-reference-assemblies/v4.7.1.debbak
	find ./external/binary-reference-assemblies/v4.7.1/ -name \*.dll -print -delete
	cd ./external/binary-reference-assemblies/ && MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ V=1 CSC="$(CURDIR)/runtime/mono-wrapper $(CURDIR)/mcs/class/lib/net_4_x-linux/mcs.exe" make

	touch $@

test: test-stamp
test-stamp: build-stamp
	-$(MINI_TEST)
	-$(MONO_BOEHM_TEST)
	-$(MONO_SGEN_TEST)
	-$(KILL_MONO)
	# funny bug-459094.cs creates too long directory names which
	# pbuilder is unable to remove, eh
	rm -rf mono/tests/abcde12345abcde12345abcde12345abcde12345/
	touch $@

clean:
	echo "distro is $(DISTRO)"
	dh_testdir
	dh_testroot
ifneq ("$(wildcard external/binary-reference-assemblies/v4.7.1.debbak)","")
		rm -rf external/binary-reference-assemblies/v4.7.1
		mv external/binary-reference-assemblies/v4.7.1.debbak external/binary-reference-assemblies/v4.7.1
endif
	[ ! -f Makefile ] || $(MAKE) distclean
	# distclean misses stuff
	find -name "*.mdb" -delete
	find ./external/binary-reference-assemblies/ -name "*.dll" -not -path "./external/binary-reference-assemblies/v4.7.1/*" -print -delete
	rm -rf mcs/class/lib/basic/ \
	       mcs/class/lib/net_4_5/

	-cd debian/detector && $(MAKE) clean
	rm -f debian/MonoGetAssemblyName.exe

	# clean stuff handled by autoreconf
	rm -rf configure config.sub config.guess aclocal.m4 autom4te.cache/
	find . -name "Makefile.in" -delete

	rm -f mcs/packages/*.dll mcs/packages/*.exe* mcs/packages/*.rsp
	rm -f autoreconf-stamp
	rm -f configure-*-stamp
	rm -f build-*-stamp
	rm -f install-*-stamp

	dh_clean

install: install-stamp
install-stamp:
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	cd mcs/jay && \
		$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

	# don't want docs of bundled libgc
	rm -rf debian/tmp/usr/share/libgc-mono
	# Mono.Security.Win32.dll is only useful on windows, as it wrap the win api
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.Security.Win32/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/Mono.Security.Win32.dll*
	# we don't ship bundled nunit of mono
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/pkgconfig/mono-nunit.pc
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/nunit*/
	rm -f  $(CURDIR)/debian/tmp/usr/bin/nunit*

	# mono 2.10.1 bug, prj2make was removed but the start script not
	rm -f $(CURDIR)/debian/tmp/usr/bin/prj2make

	# copy missing 2.0 manpages
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/al.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/al2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mcs.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/dmcs.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/mono-service2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/wsdl2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/gacutil2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/monop.1 \
	   $(CURDIR)/debian/tmp/usr/share/man/man1/monop2.1
	cp $(CURDIR)/debian/tmp/usr/share/man/man1/resgen.1 \
